/// <reference types="react" />
import * as tf from '@tensorflow/tfjs';
export interface GraphModel extends tf.GraphModel {
    name?: string;
}
export interface LayersModel extends tf.LayersModel {
}
export interface UseModelProps extends LoadOptionsType {
    model?: any;
    modelUrl?: string | undefined;
}
export interface LoadOptionsType {
    layers?: boolean;
}
export declare type ModelContext = {
    model: ModelInterface;
} | null;
export declare type ModelInterface = GraphModel | LayersModel | null;
export interface ModelProviderProps {
    url?: string;
    model?: any;
    children?: React.ReactNode;
    layerModel?: boolean;
}
export interface ModelProviderState {
    model: ModelInterface;
}
export interface AttachWebcamOptions extends MediaStreamConstraints {
    width?: number;
    height?: number;
    facingMode?: string;
}
export interface UsePredictionProps extends UseModelProps {
    predictConfig?: tf.ModelPredictConfig;
    useExecute?: boolean;
    outputName?: string;
}
export declare type Prediction = tf.Tensor | tf.Tensor[] | tf.NamedTensorMap | null;
export declare type setDataRef = (data: tf.Tensor) => void;
export declare let PredictionReturn: [setDataRef, Prediction];
export interface UseClassifierProps extends UsePredictionProps {
    returns?: number;
    classes?: {
        [classId: number]: string;
    };
}
export declare type ClassifiedResults = Array<{
    class: string;
    probability: number;
}>;
export declare type NonClassifiedResults = Array<{
    class: number;
    probability: number;
}>;
export declare type Classification = ClassifiedResults | NonClassifiedResults | null;
export declare let ClassificationReturn: [setDataRef, Classification];
export declare let UseDataRefReturn: [tf.Tensor | null, setDataRef];
